<?php
/* Form Mailer - prepares and emails data submited from a form to a designated person

Adapted by:
   Richard L. Bowman
   http://www.edtechbybowman.net
to allow for the emailing of all values from any number and type
of form elements.

This version last modified 2-Sep-2010

To email data from any number of form elements on a web page,
the calling web page needs to call this php script in the <form>
HTML tag. Also, the 'block_spam_bots' value must be correctly 
calculated on the calling web page and identified below. The 
default value is 4*3=12. Thus the user can ignore making a change
on this script if the value is correctly caltuclated on the calling
web page through a hidden input form element. Check out the webpage
examples at the above web address to see how to implement this
script from a web page. 

The security measures and anti-spam code is from an original
program found at:
   http://www.TheDemoSite.co.uk
   phpFormMailer v2.6
   last updated 2-Dec-2009

*/

// ------- variables that should or must be changed ------------
// ------- updated: 1-Apr-11 ----------------------------------
$replyemail="richard.bowman@edtechbybowman.net"; 
//change to your email address

$email = "richard.bowman@edtechbybowman.net";
//change to the email address you wish for this email to appear to have come from

$name = "Web User";
//this may be changed as you wish, but it can stay the same

$subject = "JavaScript and Forms Site";
//change to the subject that tells you what web form this email comes from

$redirect="FormNotice.html"; 
//the "thank-you" file to be loaded after a form is submitted successfully

// -------- No changes required below this point ----------------------------
//
//check to see if correct bot stopper value has been passed
if($_POST["block_spam_bots"]!=12)
//You may change this but remember to change it in the calling web page, too.
{
 echo '<h2>ERROR - Email not sent. Anti-spam enacted.';
 exit;
}
//check user input for possible header injection attempts!
function is_forbidden($str,$check_all_patterns = true)
{
 $patterns[0] = '/content-type:/';
 $patterns[1] = '/mime-version/';
 $patterns[2] = '/multipart/';
 $patterns[3] = '/Content-Transfer-Encoding/';
 $patterns[4] = '/to:/';
 $patterns[5] = '/cc:/';
 $patterns[6] = '/bcc:/';
 $forbidden = 0;
 for ($i=0; $i<count($patterns); $i++)
  {
   $forbidden = preg_match($patterns[$i], strtolower($str));
   if ($forbidden) break;
  }
 //check for line breaks if checking all patterns
 if ($check_all_patterns AND !$forbidden) $forbidden = preg_match("/(%0a|%0d|\\n+|\\r+)/i", $str);
 if ($forbidden)
 {
  echo "<font color=red><center><h3>STOP! Message not sent.</font></h3><br><b>
        The text you entered is forbidden, it includes one or more of the following:
        <br><textarea rows=9 cols=25>";
  foreach ($patterns as $key => $value) echo trim($value,"/")."\n";
  echo "\\n\n\\r</textarea><br>Click back on your browser, remove the above characters and try again.
        </b><br><br><br><br>Thankfully protected by phpFormMailer freely available from:
        <a href=\"http://thedemosite.co.uk/phpformmailer/\">http://thedemosite.co.uk/phpformmailer/</a>";
  exit();
 }
}

foreach ($_POST as $element => $value)
{
 is_forbidden($value, false); //checks all input values but allow line breaks
}

//this packages all of the form data into the message of the email to be sent
$message = "";
foreach ($_POST as $element => $value) {
  if (($element != "block_spam_bots") && ($element != "email2")) {
    $message = "$message \n$element = $value";
  }
}

//this mails the message to the designated person and shows a thank-you screen
mail("$replyemail",
     "$subject",
     "$message",
     "From: $email\nReply-To: $email");
header("Location: $redirect"); //sends the user to the "thank-you" page
?>
